uint NAME_MAX = 25 * 4 + 1;	/* multiple of 4 plus 1 */

type
    Name_t = [NAME_MAX] char,

    LabelList_t = struct {
	*LabelList_t lal_next;
	ulong lal_offset;
	bool lal_isBranch;
    },

    HunkList_t = struct {
	*HunkList_t hkl_next;
	*DefList_t hkl_symbols;
	*LabelList_t hkl_labelList;
	ulong hkl_hunkNumber;
    },

    DefList_t = struct {
	*DefList_t dfl_next;
	*char dfl_name;
	ulong dfl_offset;
    },

    RefList_t = struct {
	*RefList_t rfl_next;
	*char rfl_name;
	ulong rfl_count;
	*ulong rfl_refs;
    },

    RelocList_t = struct {
	*RelocList_t rll_next;
	ulong rll_hunkNumber;
	ulong rll_count;
	*ulong rll_refs;
    },

    RelocEntry_t = struct {
	ulong rle_offset;
	union {
	    *HunkList_t rle_hunk;
	    *RefList_t rle_ref;
	} rle_u;
	bool rle_isRef;
    },

    Hunk_t = struct {
	*DefList_t h_defList, h_absList, h_lastLabel;
	*RefList_t h_refList;
	*RelocList_t h_relocList;
	*RelocEntry_t h_relocEntries, h_lastReloc;
	ulong h_relocCount, h_hunkNumber;
	arbptr h_bytes;
	ulong h_bytesLength;
	*byte h_labelMap;
	*byte h_branchMap;
	ulong h_mapLength;
	bool h_labelsOK;
    };

ulong
    HUNK_ILLEGAL = 0,

    HUNK_UNIT = 999,
    HUNK_NAME = 1000,
    HUNK_CODE = 1001,
    HUNK_DATA = 1002,
    HUNK_BSS = 1003,
    HUNK_RELOC32 = 1004,
    HUNK_RELOC16 = 1005,
    HUNK_RELOC8 = 1006,
    HUNK_EXT = 1007,
    HUNK_SYMBOL = 1008,
    HUNK_DEBUG = 1009,
    HUNK_END = 1010,
    HUNK_HEADER = 1011,
    HUNK_OVERLAY = 1013,
    HUNK_BREAK = 1014,
    HUNK_RELOC_REL32 = 1015,
    HUNK_RELOC_REL16 = 1016,
    HUNK_RELOC_REL8 = 1017,
    HUNK_LIB = 1018,
    HUNK_DIRECTORY = 1019;

uint
    EXT_SYMB = 0,
    EXT_DEF = 1,
    EXT_ABS = 2,
    EXT_RES = 3,
    EXT_REF32 = 129,
    EXT_COMMON = 130,
    EXT_REF16 = 131,
    EXT_REF8 = 132,
    EXT_REF_REL32 = 133,
    EXT_REF_REL16 = 134,
    EXT_REF_REL8 = 135;

ulong NO_HUNK = 0xffffffff;
